/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.sobek.innovations.jaxrs;

import de.schulung.sampleservlet.Konto;
import de.schulung.sampleservlet.Kredit;
import de.schulung.sampleservlet.KreditDatenbank;
import de.schulung.sampleservlet.Kunde;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.ws.rs.Consumes;
import javax.ws.rs.DELETE;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

/**
 *
 * @author rafael
 */
@Path("/kredite")
public class KreditService {
    
    private KreditDatenbank db = new KreditDatenbank();
    

    
    @GET
    @Path("/")
    @Consumes("*/*")
    @Produces("application/json")
    public Response getKredite() {
        return Response.status(200).entity(this.db.getKreditMap().values()).build();
    }
    
    @GET
    @Path("/{id}")
    @Consumes("*/*")
    @Produces("application/json")
    public Response getKredit(@PathParam("id") Long id) {
        if (this.db.getKreditMap().containsKey(id)) {
            return Response.status(200).entity(this.db.getKreditMap().get(id)).build();
        } else {
            return Response.status(404).build();
        }
        
    }
    
    @POST
    @Path("/{id}")
    @Consumes(MediaType.APPLICATION_JSON)
    @Produces("application/json")
    public Response createKredit(Kredit kredit) {
        Kredit kreditCreated = this.db.createKredit(kredit);
        return Response.status(200).entity(kreditCreated).build();
    }
    
    @PUT
    @Path("/{id}")
    @Consumes(MediaType.APPLICATION_JSON)
    @Produces("application/json")
    public Response updateKredit(Long id, Kredit kredit) {
        kredit.setId(id);
        this.db.updateKredit(id, kredit);
        return Response.status(200).build();
    }
    
    @DELETE
    @Path("/{id}")
    @Produces("application/json")
    public Response deleteKredit(Long id) {
        if (this.db.getKreditMap().containsKey(id)) {
            Kredit removedKredit = this.db.getKreditMap().remove(id);
            return Response.status(200).entity(removedKredit).build();
        } else {
            return Response.status(404).build();
        }
    }
    
}
